package org.rcisoft.business.dataDict.Controller;


/*固定导入*/
import cn.hutool.json.JSONUtil;
import io.swagger.v3.oas.annotations.Operation;
import org.rcisoft.core.anno.CyOpeLogAnno;
import org.rcisoft.core.operlog.enums.CyLogTypeEnum;
import org.rcisoft.core.service.impl.CyRedisServiceImpl;
import org.rcisoft.sys.dictionary.dao.DictDataRepository;
import org.rcisoft.sys.dictionary.dao.DictionaryRepository;
import org.rcisoft.sys.dictionary.entity.DictData;
import org.rcisoft.sys.dictionary.entity.Dictionary;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
* Created by cy on 2025年1月6日 下午1:44:44.
*/
@RestController
@RequestMapping("/dataDict")
public class DataDictController{


    @Autowired
    private CyRedisServiceImpl cyRedisServiceImpl;
    @Autowired
    private DictDataRepository dictDataRepository;
    @Autowired
    private DictionaryRepository dictionaryRepository;

    private String DICT_TYPE_REDIS_PREKEY = "DICT:TYPE:";

    @PreAuthorize("@cyPerm.hasPerm('sys:dict:list')")
    @CyOpeLogAnno(title = "system-刷新数据字典到redis-刷新数据字典到redis", businessType = CyLogTypeEnum.QUERY)
    @Operation(summary="刷新数据字典到redis", description="刷新数据字典到redis")
    @GetMapping(value = "/refresh")
    public void refresh() {
        //清除redis中字典数据
        cyRedisServiceImpl.del(DICT_TYPE_REDIS_PREKEY + "*");
        //查询redis中所有的dictType
        List<Dictionary> dictTypeList = dictionaryRepository.selectAllType();
        if (dictTypeList.size() > 0){
            for (Dictionary dictType : dictTypeList) {
                List<DictData> dictDatas = dictDataRepository.selectDictDataByType(dictType.getDictType());
                if (dictDatas != null && !dictDatas.isEmpty()) {
                    cyRedisServiceImpl.set(DICT_TYPE_REDIS_PREKEY + dictType.getDictType(), JSONUtil.toJsonStr(dictDatas));
                }
            }
        }
    }

}
