package org.rcisoft.business.opmArticleCommentMessageError.controller;


/*固定导入*/
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.media.Schema;
import io.swagger.v3.oas.annotations.Parameters;
import io.swagger.v3.oas.annotations.Operation;
import org.rcisoft.business.opmArticleCommentMessageError.entity.OpmArticleCommentMessageError;
import org.rcisoft.business.opmArticleCommentMessageError.service.OpmArticleCommentMessageErrorService;
import org.rcisoft.core.anno.CyOpeLogAnno;
import org.rcisoft.core.controller.CyPaginationController;
import org.rcisoft.core.operlog.enums.CyLogTypeEnum;
import org.rcisoft.core.util.CyEpExcelUtil;
import org.springframework.validation.BindingResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import org.rcisoft.core.result.CyResult;
import org.rcisoft.core.util.CyResultGenUtil;
import org.rcisoft.core.model.CyPersistModel;
import org.rcisoft.core.constant.CyMessCons;
import org.rcisoft.core.model.CyGridModel;
import jakarta.servlet.http.HttpServletResponse;
import javax.validation.Valid;
import java.util.List;

/**
* Created by cy on 2025年4月27日 下午3:36:30.
*/
@RestController
@RequestMapping("/opmArticleCommentMessageError")
public class OpmArticleCommentMessageErrorController extends CyPaginationController<OpmArticleCommentMessageError> {


    @Autowired
    private OpmArticleCommentMessageErrorService opmArticleCommentMessageErrorServiceImpl;

//    @PreAuthorize("@cyPerm.hasPerm('sys:articleCommentMessageError:add')")
    @CyOpeLogAnno(title = "system-动态/评论/留言错误表管理-新增动态/评论/留言错误表", businessType = CyLogTypeEnum.INSERT)
    @Operation(summary="添加动态/评论/留言错误表", description="添加动态/评论/留言错误表")
    @PostMapping(value = "/add")
    public CyResult add(@Valid OpmArticleCommentMessageError opmArticleCommentMessageError, BindingResult bindingResult) {
        CyPersistModel data = opmArticleCommentMessageErrorServiceImpl.persist(opmArticleCommentMessageError);
        return CyResultGenUtil.builder(data,
            CyMessCons.MESSAGE_ALERT_SUCCESS,
            CyMessCons.MESSAGE_ALERT_ERROR,
        opmArticleCommentMessageError);
    }
    //@PreAuthorize("@cyPerm.hasPerm('sys:articleCommentMessageError:delete')")
    @CyOpeLogAnno(title = "system-动态/评论/留言错误表管理-删除动态/评论/留言错误表", businessType = CyLogTypeEnum.DELETE)
    @Operation(summary="逻辑删除动态/评论/留言错误表", description="逻辑删除动态/评论/留言错误表")
    @Parameters({@Parameter(name = "businessId", description = "businessId", required = true,  schema = @Schema(type = "string"))})
    @DeleteMapping("/deleteLogical/{businessId:\\w+}")
    public CyResult deleteLogical(@PathVariable int businessId,OpmArticleCommentMessageError opmArticleCommentMessageError) {
        opmArticleCommentMessageError.setBusinessId(businessId);
        CyPersistModel data = opmArticleCommentMessageErrorServiceImpl.removeLogical(opmArticleCommentMessageError);
        return CyResultGenUtil.builder(data,
            CyMessCons.MESSAGE_ALERT_SUCCESS,
            CyMessCons.MESSAGE_ALERT_ERROR,
        businessId);
    }
    //@PreAuthorize("@cyPerm.hasPerm('sys:articleCommentMessageError:delete')")
    @CyOpeLogAnno(title = "system-动态/评论/留言错误表管理-删除动态/评论/留言错误表", businessType = CyLogTypeEnum.DELETE)
    @Operation(summary="删除动态/评论/留言错误表", description="删除动态/评论/留言错误表")
    @Parameters({@Parameter(name = "businessId", description = "businessId", required = true,  schema = @Schema(type = "string"))})
    @DeleteMapping("/delete/{businessId:\\w+}")
    public CyResult delete(@PathVariable int businessId,OpmArticleCommentMessageError opmArticleCommentMessageError) {
        opmArticleCommentMessageError.setBusinessId(businessId);
        CyPersistModel data = opmArticleCommentMessageErrorServiceImpl.remove(opmArticleCommentMessageError);
        return CyResultGenUtil.builder(data,
            CyMessCons.MESSAGE_ALERT_SUCCESS,
            CyMessCons.MESSAGE_ALERT_ERROR,
        businessId);
    }

    //@PreAuthorize("@cyPerm.hasPerm('sys:articleCommentMessageError:update')")
    @CyOpeLogAnno(title = "system-动态/评论/留言错误表管理-修改动态/评论/留言错误表", businessType = CyLogTypeEnum.UPDATE)
    @Operation(summary="修改动态/评论/留言错误表", description="修改动态/评论/留言错误表")
    @Parameters({@Parameter(name = "businessId", description = "businessId", required = false,  schema = @Schema(type = "string"))})
    @PutMapping("/update/{businessId:\\w+}")
    public CyResult update(@PathVariable int businessId, @Valid OpmArticleCommentMessageError opmArticleCommentMessageError, BindingResult bindingResult) {
        opmArticleCommentMessageError.setBusinessId(businessId);
        CyPersistModel data = opmArticleCommentMessageErrorServiceImpl.merge(opmArticleCommentMessageError);
        return CyResultGenUtil.builder(data,
            CyMessCons.MESSAGE_ALERT_SUCCESS,
            CyMessCons.MESSAGE_ALERT_ERROR,
        opmArticleCommentMessageError);
    }

    //@PreAuthorize("@cyPerm.hasPerm('sys:articleCommentMessageError:query')")
    @CyOpeLogAnno(title = "system-动态/评论/留言错误表管理-查询动态/评论/留言错误表", businessType = CyLogTypeEnum.QUERY)
    @Operation(summary="查询单一动态/评论/留言错误表", description="查询单一动态/评论/留言错误表")
    @Parameters({@Parameter(name = "businessId", description = "businessId", required = true,  schema = @Schema(type = "string"))})
    @GetMapping("/detail/{businessId:\\w+}")
    public CyResult detail(@PathVariable int businessId) {
        return CyResultGenUtil.builder(new CyPersistModel(1),
            CyMessCons.MESSAGE_ALERT_SUCCESS,
            CyMessCons.MESSAGE_ALERT_ERROR,
        opmArticleCommentMessageErrorServiceImpl.findById(businessId));
    }

    //@PreAuthorize("@cyPerm.hasPerm('sys:articleCommentMessageError:list')")
    @CyOpeLogAnno(title = "system-动态/评论/留言错误表管理-查询动态/评论/留言错误表", businessType = CyLogTypeEnum.QUERY)
    @Operation(summary="查询动态/评论/留言错误表集合", description="查询动态/评论/留言错误表集合")
    @GetMapping(value = "/listAll")
    public CyResult listAll(OpmArticleCommentMessageError opmArticleCommentMessageError) {
        return CyResultGenUtil.builder(new CyPersistModel(1),
            CyMessCons.MESSAGE_ALERT_SUCCESS,
            CyMessCons.MESSAGE_ALERT_ERROR,
            opmArticleCommentMessageErrorServiceImpl.findAll(opmArticleCommentMessageError));
    }

    //@PreAuthorize("@cyPerm.hasPerm('sys:articleCommentMessageError:list')")
    @CyOpeLogAnno(title = "system-动态/评论/留言错误表管理-查询动态/评论/留言错误表", businessType = CyLogTypeEnum.QUERY)
    @Operation(summary="分页查询动态/评论/留言错误表集合", description="分页查询动态/评论/留言错误表集合")
    @GetMapping(value = "/list")
    public CyGridModel listByPagination(OpmArticleCommentMessageError opmArticleCommentMessageError) {
        opmArticleCommentMessageErrorServiceImpl.findAllByPagination(getPaginationUtility(), opmArticleCommentMessageError);
        return getGridModelResponse();
    }

    @CyOpeLogAnno(title = "system-动态/评论/留言错误表管理-查询动态/评论/留言错误表", businessType = CyLogTypeEnum.EXPORT)
    @Operation(summary = "导出动态/评论/留言错误表信息", description = "导出动态/评论/留言错误表信息")
    @GetMapping(value = "/export")
    public void outOpmArticleCommentMessageError(HttpServletResponse response,OpmArticleCommentMessageError opmArticleCommentMessageError,@PathVariable @RequestParam(defaultValue = "0") String excelId) {
        String excelName="";
        switch(excelId){
            case "0": excelName="动态/评论/留言错误表信息.xls";break;
            case "1": excelName="动态/评论/留言错误表信息.xlsx";break;
            case "2": excelName="动态/评论/留言错误表信息.csv";break;
        }
        List<OpmArticleCommentMessageError> opmArticleCommentMessageErrorList = opmArticleCommentMessageErrorServiceImpl.export(opmArticleCommentMessageError);
        CyEpExcelUtil.exportExcel(opmArticleCommentMessageErrorList, "动态/评论/留言错误表信息", "动态/评论/留言错误表信息", OpmArticleCommentMessageError.class, excelName, response);
    }
}
